package main

import "fmt"

func gen(
	intCh chan int,
	stringCh chan string,
) {
	intCh <- 1
	stringCh <- "abc"
	intCh <- 2
	stringCh <- "ABC"
	intCh <- 3
	stringCh <- "done"
}

func main() {
	intCh := make(chan int)
	stringCh := make(chan string)
	go gen(intCh, stringCh)

	for {
		select {
		case i := <-intCh:
			fmt.Print(i)
		case s := <-stringCh:
			fmt.Print(s)
			if s == "done" {
				return
			}
		default:
			fmt.Print(".")
		}
	}
}
