package main

import (
	"fmt"
	"strconv"
)

func parser(s <-chan string) (<-chan int, <-chan error) {
	ch := make(chan int)
	errCh := make(chan error)

	go func() {
		for str := range s {
			i, err := strconv.Atoi(str)
			if err != nil {
				errCh <- err
			}
			ch <- i
		}
	}()

	return ch, errCh
}

func main() {
	ch := make(chan string)
	resultCh, errCh := parser(ch)

	ss := []string{"1", "2", "3", "abc"}
	for _, s := range ss {
		ch <- s
		select {
		case result := <-resultCh:
			fmt.Printf("%d(%T)\n", result, result)
		case err := <-errCh:
			fmt.Println("error!", err)
			return
		}
	}
	close(ch)
}
