package main

import (
	"fmt"
	"math/rand"
	"time"
)

func gen(nums []int) <-chan int {
	ch := make(chan int)
	go func() {
		for _, n := range nums {
			time.Sleep(200 * time.Millisecond)
			ch <- n
		}
		close(ch)
	}()
	return ch
}

// 2乗する
func sq(in <-chan int) <-chan int {
	out := make(chan int)
	go func() {
		for x := range in {
			out <- x * x
		}
		close(out)
	}()
	return out
}

// 半分にする
func halve(in <-chan int) <-chan int {
	out := make(chan int)
	go func() {
		for x := range in {
			out <- x / 2
		}
		close(out)
	}()
	return out
}

// 演習
// 剰余演算
func mod7(in <-chan int) <-chan int {
	out := make(chan int)
	go func() {
		for x := range in {
			out <- x % 7
		}
		close(out)
	}()
	return out
}

func main() {
	rand.Seed(time.Now().UnixMilli())
	nums := make([]int, 0, 10)
	for i := 0; i < 10; i++ {
		nums = append(nums, rand.Intn(10))
	}

	fmt.Print("   x: ")
	for x := range gen(nums) {
		fmt.Printf("%2d ", x)
	}
	fmt.Print("\n")

	fmt.Print("*= x: ")
	for x := range sq(gen(nums)) {
		fmt.Printf("%2d ", x)
	}
	fmt.Print("\n")

	fmt.Print("/= 2: ")
	for x := range halve(sq(gen(nums))) {
		fmt.Printf("%2d ", x)
	}
	fmt.Print("\n")

	// 演習
	fmt.Print("%= 7: ")
	for x := range mod7(halve(sq(gen(nums)))) {
		fmt.Printf("%2d ", x)
	}
	fmt.Print("\n")
}
